=== modified file 'grackle/client.py'
--- grackle/client.py	2012-01-30 20:37:22 +0000
+++ grackle/client.py	2012-01-30 21:30:02 +0000
@@ -118,13 +118,16 @@
             parameters['headers'] = headers
         if max_body_length is not None:
             parameters['max_body_length'] = max_body_length
-        if display_type not in SUPPORTED_DISPLAY_TYPES:
-            raise UnsupportedDisplayType
         parameters['display_type'] = display_type
         parameters['include_hidden'] = include_hidden
         query = {'parameters': simplejson.dumps(parameters)}
         response = self._method_archive('GET', archive_id, query)
         if response.status == httplib.BAD_REQUEST:
-            raise UnsupportedOrder
+            if response.reason == 'Unsupported order':
+                raise UnsupportedOrder
+            elif response.reason == 'Unsupported display_type':
+                raise UnsupportedDisplayType
+            else:
+                raise ValueError('Bad request')
         data = response.read()
         return simplejson.loads(data)

=== modified file 'grackle/tests/test_client.py'
--- grackle/tests/test_client.py	2012-01-30 20:57:08 +0000
+++ grackle/tests/test_client.py	2012-01-30 21:30:02 +0000
@@ -226,9 +226,13 @@
                 self.send_response(httplib.OK)
                 self.end_headers()
                 self.wfile.write(simplejson.dumps(response))
+            except UnsupportedDisplayType:
+                self.send_response(
+                    httplib.BAD_REQUEST, 'Unsupported display_type')
+                return
             except UnsupportedOrder:
-                self.send_response(httplib.BAD_REQUEST)
-                self.wfile.write('Unsupported order')
+                self.send_response(
+                    httplib.BAD_REQUEST, 'Unsupported order')
                 return
 
     def log_message(self, format, *args):

